#
# Table structure for table `u15_dataobjects`
#

CREATE TABLE u15_dataobjects (
  id varchar(30) NOT NULL default '0',
  uid varchar(15) NOT NULL default '',
  gid_r varchar(10) NOT NULL default '',
  gid_w varchar(10) NOT NULL default '',
  gid_i varchar(10) NOT NULL default '',
  parent_id varchar(30) NOT NULL default '0',
  _date datetime NOT NULL default '0000-00-00 00:00:00',
  host varchar(15) NOT NULL default '',
  title varchar(100) NOT NULL default '',
  _table varchar(50) NOT NULL default '',
  help_cfg varchar(255) NOT NULL default '',
  upload_folder varchar(255) NOT NULL default '',
  parentid_field varchar(50) NOT NULL default '',
  lng_files varchar(255) NOT NULL default '',
  filter_id varchar(30) NOT NULL default '',
  id_type char(1) NOT NULL default '',
  editable_id char(1) NOT NULL default '',
  code_before text NOT NULL,
  code_after text NOT NULL,
  gid_rm varchar(10) NOT NULL default '',
  gid_wm varchar(10) NOT NULL default '',
  gid_im varchar(10) NOT NULL default '',
  code_before_update text NOT NULL,
  code_before_delete text NOT NULL,
  code_after_add text NOT NULL,
  _index char(1) NOT NULL default '',
  descr text NOT NULL,
  admin_menu text NOT NULL,
  code_after_delete text NOT NULL,
  code_after_update text NOT NULL,
  code_before_add text NOT NULL,
  PRIMARY KEY  (id),
  KEY id (id)
) TYPE=MyISAM;

#
# Dumping data for table `u15_dataobjects`
#

INSERT INTO u15_dataobjects VALUES ('sbs_wp_u15_templates', 'admin', '', '', '', '0', '2006-08-16 14:50:01', '127.0.0.1', 'U15 Templates', 'u15_templates', 'modules/u15/help/help_config.php', '', '', '', '', '1', '1', '', '', '', '', '', '', '', '', '0', 'List of all templates in system. Be careful: you can damage core of SBS "Web-Pro"!', '', '', '', '');
INSERT INTO u15_dataobjects VALUES ('sbs_wp_u15_filters', 'admin', '', '', '', '0', '2006-08-16 14:57:02', '127.0.0.1', 'U15 Filters', 'u15_filters', 'modules/u15/help/help_config.php', '', '', '', '', '1', '1', '', '', '', '', '', '', '', '', '0', 'List of all filters in system. Be careful: you can damage core of SBS "Web-Pro"!', '', '', '', '');
INSERT INTO u15_dataobjects VALUES ('sbs_wp_u15_do_fields', 'admin', '', '', '', '0', '2006-08-16 14:59:34', '127.0.0.1', 'U15 Dataobject fields', 'u15_do_fields', 'modules/u15/help/help_config.php', '', '', '', 'sbs_wp_u15_do_select', '1', '0', '', '', '', '', '', '$mobj->SQL = "select _name, _index from u15_do_fields where id=\'".$u15id."\'";\r\n$R = $mobj->DB_db_query();\r\n$mobj->SQL = "select _table from u15_dataobjects where id=\'".$fields[do_id][0]."\'";\r\n$Rdo = $mobj->DB_db_query();\r\nif ($fields[_type][0]==\'CHAR\' or $fields[_type][0]==\'VARCHAR\' or $fields[_type][0]==\'INT\') $tmp_length = "(".$fields[_length].")"; else $tmp_length = \'\';\r\n$mobj->SQL = "ALTER TABLE `".$mobj->DB_result($Rdo, 0)."` CHANGE `".$mobj->DB_result($R, 0, \'_name\')."` `".$fields[_name]."` ".$fields[_type][0]."$tmp_length NOT NULL;";\r\n$mobj->DB_db_query();\r\n\r\n// Index\r\nif ($fields[_index]) {\r\n  if ($mobj->DB_result($R, 0, \'_index\') != \'1\') { // If index not found\r\n    $mobj->SQL = "ALTER TABLE `".$mobj->DB_result($Rdo, 0)."` ADD INDEX(`".$fields[_name]."`)";\r\n    $mobj->DB_db_query();\r\n  }\r\n} else {\r\n  $mobj->SQL = "ALTER TABLE `".$mobj->DB_result($Rdo, 0)."` DROP INDEX `".$fields[_name]."`";\r\n  $mobj->DB_db_query();\r\n}', '$mobj->SQL = "select _name,do_id from u15_do_fields where id=\'".$u15id."\'";\r\n$R = $mobj->DB_db_query();\r\n$mobj->SQL = "select _table from u15_dataobjects where id=\'".$mobj->DB_result($R,0,\'do_id\')."\'";\r\n$Rdo = $mobj->DB_db_query();\r\n$mobj->SQL = "ALTER TABLE `".$mobj->DB_result($Rdo,0)."` DROP `".$mobj->DB_result($R,0,\'_name\')."`";\r\n$mobj->DB_db_query();', '$mobj->SQL = "select _table from u15_dataobjects where id=\'".$fields[do_id][0]."\'";\r\n$Rdo = $mobj->DB_db_query();\r\nif ($fields[_type][0]==\'CHAR\' or $fields[_type][0]==\'VARCHAR\' or $fields[_type][0]==\'INT\') $tmp_length = "(".$fields[_length].")"; else $tmp_length = \'\';\r\n$mobj->SQL = "ALTER TABLE `".$mobj->DB_result($Rdo, 0)."` ADD `".$fields[_name]."` ".$fields[_type][0]."$tmp_length NOT NULL;";\r\n$mobj->DB_db_query();\r\n\r\n// Index\r\nif ($fields[_index]) {\r\n  $mobj->SQL = "ALTER TABLE `".$mobj->DB_result($Rdo, 0)."` ADD INDEX(`".$fields[_name]."`)";\r\n  $mobj->DB_db_query();\r\n}', '0', 'List of fields of all dataobjects in system. Be careful: you can damage core of SBS "Web-Pro"!', '', '', '', '');
INSERT INTO u15_dataobjects VALUES ('sbs_wp_u15_dataobjects', 'admin', '', '', '', '0', '2006-08-16 15:00:10', '127.0.0.1', 'U15 Dataobjects', 'u15_dataobjects', 'modules/u15/help/help_config.php', '', '', '', '', '1', '1', '', '', '', '', '', '$res = $dataobject->u15update_dataobject($u15id, $fields[_table], $fields[id]);', '$dataobject->u15delete_dataobject($u15id);', '$dataobject->u15create_dataobject($res[id], $fields[title], $fields[_table], $fields[id_type][0]);', '0', 'List of all dataobjects in system. Be careful: you can damage core of SBS "Web-Pro"!', '', '', '', '');
# --------------------------------------------------------

#
# Table structure for table `u15_do_fields`
#

CREATE TABLE u15_do_fields (
  id varchar(30) NOT NULL default '',
  uid varchar(15) NOT NULL default '',
  gid_r varchar(10) NOT NULL default '',
  gid_w varchar(10) NOT NULL default '',
  gid_i varchar(10) NOT NULL default '',
  parent_id varchar(30) NOT NULL default '0',
  _date datetime NOT NULL default '0000-00-00 00:00:00',
  host varchar(15) NOT NULL default '',
  _name varchar(50) NOT NULL default '',
  _type varchar(10) NOT NULL default '',
  _length varchar(5) NOT NULL default '',
  itype varchar(10) NOT NULL default '',
  add_params varchar(255) NOT NULL default '',
  ititle varchar(100) NOT NULL default '',
  inumber varchar(4) NOT NULL default '',
  _gid_r varchar(20) NOT NULL default '',
  help_id varchar(50) NOT NULL default '',
  _index char(1) NOT NULL default '',
  do_id varchar(30) NOT NULL default '',
  descr varchar(255) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY id (id)
) TYPE=MyISAM;

#
# Dumping data for table `u15_do_fields`
#

INSERT INTO u15_do_fields VALUES ('44ed4b079d13e', 'admin', '', '', '', '0', '2006-08-16 16:38:55', '127.0.0.1', '_name', 'VARCHAR', '50', 'string', '', '_LNG_U15_NAME_', '1', '', 'fields_name', '0', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b079d6da', 'admin', '', '', '', '0', '2006-08-16 16:40:29', '127.0.0.1', 'do_id', 'VARCHAR', '30', 'select', 'sbs_wp_u15_dataobjects~sbs_wp_u15_select_do_2', '_LNG_U15_DOID_', '11', '', 'fields_do_id', '0', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b079dccc', 'admin', '', '', '', '0', '2006-08-16 16:50:54', '127.0.0.1', '_type', 'VARCHAR', '10', 'select', '$dataobject->column_types~~~array', '_LNG_U15_TYPE_', '2', '', 'fields_type', '0', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b079e5f5', 'admin', '', '', '', '0', '2006-08-16 16:52:05', '127.0.0.1', '_length', 'VARCHAR', '5', 'string', '', '_LNG_U15_LENGTH_', '3', '', 'fields_length', '0', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b079eb19', 'admin', '', '', '', '0', '2006-08-16 16:52:50', '127.0.0.1', 'itype', 'VARCHAR', '10', 'select', '$dataobject->inttypes~~~array', '_LNG_U15_INTTYPE_', '4', '', 'inttype', '0', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b079f031', 'admin', '', '', '', '0', '2006-08-16 16:53:41', '127.0.0.1', 'add_params', 'VARCHAR', '255', 'string', '', '_LNG_U15_ADDPARAMS_', '5', '', 'addparams', '', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b079f51f', 'admin', '', '', '', '0', '2006-08-16 16:54:17', '127.0.0.1', 'ititle', 'VARCHAR', '100', 'string', '', '_LNG_U15_INTTITLE_', '6', '', 'inttitle', '', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b079f9da', 'admin', '', '', '', '0', '2006-08-16 16:55:04', '127.0.0.1', 'inumber', 'CHAR', '4', 'string', '', '_LNG_U15_INTNO_', '7', '', 'intno', '0', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b079fec0', 'admin', '', '', '', '0', '2006-08-16 16:55:49', '127.0.0.1', '_gid_r', 'VARCHAR', '20', 'string', '', '_LNG_U15_GIDR_', '8', '', 'gid', '', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a03a7', 'admin', '', '', '', '0', '2006-08-16 16:56:24', '127.0.0.1', 'help_id', 'VARCHAR', '50', 'string', '', '_LNG_U15_HELPID_', '9', '', 'helpid', '', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a0871', 'admin', '', '', '', '0', '2006-08-16 16:56:54', '127.0.0.1', '_index', 'CHAR', '1', 'checkbox', '', '_LNG_U15_INDEX_', '10', '', 'fields_index', '0', 'sbs_wp_u15_do_fields', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a0d6c', 'admin', '', '', '', '0', '2006-08-16 17:10:00', '127.0.0.1', 'title', 'VARCHAR', '100', 'string', '', '_LNG_U15_TITLE_', '1', '', 'obj_title', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a12ae', 'admin', '', '', '', '0', '2006-08-16 17:12:20', '127.0.0.1', '_table', 'VARCHAR', '50', 'string', '', '_LNG_U15_TABLE_', '2', '', 'table_name', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a18af', 'admin', '', '', '', '0', '2006-08-16 17:13:03', '127.0.0.1', 'help_cfg', 'VARCHAR', '255', 'string', '', '_LNG_U15_HELPCFG_', '4', '', 'help_cfg', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a1e1b', 'admin', '', '', '', '0', '2006-08-16 17:13:22', '127.0.0.1', 'upload_folder', 'VARCHAR', '255', 'string', '', '_LNG_U15_UPLOADFOLDER_', '5', '', 'upload_folder', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a268e', 'admin', '', '', '', '0', '2006-08-16 17:13:37', '127.0.0.1', 'parentid_field', 'VARCHAR', '50', 'string', '', '_LNG_U15_PARENTID_FIELD_', '6', '', 'parentid_field', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a2bec', 'admin', '', '', '', '0', '2006-08-16 17:13:54', '127.0.0.1', 'lng_files', 'VARCHAR', '255', 'string', '', '_LNG_U15_LNGFILES_', '3', '', 'lng_files', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a3450', 'admin', '', '', '', '0', '2006-08-16 17:14:11', '127.0.0.1', 'filter_id', 'VARCHAR', '30', 'select', 'sbs_wp_u15_filters~sbs_wp_u15_filter_list', '_LNG_U15_FILTER_', '7', '', 'filter_field', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a3a79', 'admin', '', '', '', '0', '2006-08-16 17:14:33', '127.0.0.1', 'id_type', 'CHAR', '1', 'select', '$dataobject->id_types~index~~array', '_LNG_U15_IDTYPE_', '8', '', 'id_type', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a3fc7', 'admin', '', '', '', '0', '2006-08-16 17:14:58', '127.0.0.1', 'editable_id', 'CHAR', '1', 'checkbox', '', '_LNG_U15_EDITABLE_ID_', '9', '', 'do_editable_id', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a44d6', 'admin', '', '', '', '0', '2006-08-16 17:15:23', '127.0.0.1', 'code_before', 'TEXT', '', 'text', '', '_LNG_U15_CODE_BEFORE_', '13', '', 'code_1', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a49d1', 'admin', '', '', '', '0', '2006-08-16 17:15:38', '127.0.0.1', 'code_after', 'TEXT', '', 'text', '', '_LNG_U15_CODE_AFTER_', '14', '', 'code_1', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a4ecd', 'admin', '', '', '', '0', '2006-08-16 17:15:54', '127.0.0.1', 'gid_rm', 'VARCHAR', '10', 'string', '', '_LNG_U15_GID_RM_', '10', '', 'gid_xm', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a5506', 'admin', '', '', '', '0', '2006-08-16 17:16:08', '127.0.0.1', 'gid_wm', 'VARCHAR', '10', 'string', '', '_LNG_U15_GID_WM_', '11', '', 'gid_xm', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a5a74', 'admin', '', '', '', '0', '2006-08-16 17:16:26', '127.0.0.1', 'gid_im', 'VARCHAR', '10', 'string', '', '_LNG_U15_GID_IM_', '12', '', 'gid_xm', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a6b85', 'admin', '', '', '', '0', '2006-08-16 17:19:54', '127.0.0.1', 'title', 'VARCHAR', '100', 'string', '', '_LNG_U15_TITLE_', '1', '', 'filter_title', '0', 'sbs_wp_u15_filters', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a70eb', 'admin', '', '', '', '0', '2006-08-16 17:20:23', '127.0.0.1', '_fields', 'TEXT', '', 'text', '', '_LNG_U15_FIELDS_', '2', '', 'make_filter', '0', 'sbs_wp_u15_filters', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a760d', 'admin', '', '', '', '0', '2006-08-16 17:22:31', '127.0.0.1', 'title', 'VARCHAR', '255', 'string', '', '', '1', '', 'cfg_title', '0', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a7b1c', 'admin', '', '', '', '0', '2006-08-16 17:23:21', '127.0.0.1', 'tmpl_record_cell', 'TEXT', '', 'text', '~200px', '', '2', '', 'cfg_tmpl_record_cell', '0', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a7fea', 'admin', '', '', '', '0', '2006-08-16 17:23:51', '127.0.0.1', 'tmpl_record_cell_empty', 'TEXT', '', 'text', '~50px', '', '3', '', 'cfg_tmpl_record_cell_empty', '0', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07a9ae1', 'admin', '', '', '', '0', '2006-08-16 17:24:13', '127.0.0.1', 'cell_divider', 'TEXT', '', 'text', '~50px', '', '4', '', 'cfg_cell_divider', '0', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07aa004', 'admin', '', '', '', '0', '2006-08-16 17:24:38', '127.0.0.1', 'row_divider', 'TEXT', '', 'text', '~50px', '', '5', '', 'cfg_row_divider', '0', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07aa505', 'admin', '', '', '', '0', '2006-08-16 17:25:08', '127.0.0.1', 'record_on_row', 'VARCHAR', '6', 'string', '', '', '6', '', 'cfg_record_on_row', '0', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07aad82', 'admin', '', '', '', '0', '2006-08-16 17:25:41', '127.0.0.1', 'record_on_page', 'VARCHAR', '6', 'string', '', '', '7', '', 'cfg_record_on_page', '0', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07ab2ce', 'admin', '', '', '', '0', '2006-08-16 17:27:14', '127.0.0.1', 'record_order', 'VARCHAR', '100', 'string', '', '', '11', '', 'cfg_record_order', '0', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07ab82e', 'admin', '', '', '', '0', '2006-08-16 17:28:21', '127.0.0.1', 'table_header', 'TEXT', '', 'text', '~50px', '', '12', '', 'cfg_table_header', '0', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07abd39', 'admin', '', '', '', '0', '2006-08-16 17:29:05', '127.0.0.1', 'sql_fields', 'VARCHAR', '255', 'text', '~20px', '', '8', '', 'cfg_sql_fields', '', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07ac27d', 'admin', '', '', '', '0', '2006-08-16 17:29:50', '127.0.0.1', 'sql_join_suffix', 'VARCHAR', '255', 'text', '~50px', '', '9', '', 'cfg_sql_join_suffix', '', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44ed4b07ac808', 'admin', '', '', '', '0', '2006-08-16 17:30:20', '127.0.0.1', 'sql_where_suffix', 'VARCHAR', '255', 'text', '~50px', '', '10', '', 'cfg_sql_where_suffix', '', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('44fb2b49cc44d', 'admin', '', '', '', '0', '2006-09-03 23:21:45', '127.0.0.1', 'code_before_update', 'TEXT', '', 'text', '~100px', '', '16', '', 'code_2', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44fb2f2cecb37', 'admin', '', '', '', '0', '2006-09-03 23:38:20', '127.0.0.1', 'code_before_delete', 'TEXT', '', 'text', '~100px', '', '17', '', 'code_2', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44fb313348448', 'admin', '', '', '', '0', '2006-09-03 23:46:59', '127.0.0.1', 'code_after_add', 'TEXT', '', 'text', '~100px', '', '15', '', 'code_2', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('44ffb26a8628e', 'admin', '', '', '', '0', '2006-09-07 09:47:22', '127.0.0.1', '_index', 'CHAR', '1', 'checkbox', '', '', '18', '', '', '', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('460519b8935f5', 'admin', '', '', '', '0', '2007-03-24 15:29:44', '127.0.0.1', 'descr', 'TEXT', '', 'text', '', '_LNG_U15_DESCR_', '19', '', 'do_descr', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('460564d6d8d90', 'admin', '', '', '', '0', '2007-03-24 20:50:14', '127.0.0.1', 'admin_menu', 'TEXT', '', 'text', '', '_LNG_U15_ADMINMENU_', '20', '', 'do_admin_menu', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('46081a318d6e9', 'admin', '', '', '', '0', '2007-03-26 23:08:33', '127.0.0.1', 'code_after_delete', 'TEXT', '', 'text', '~100px', '', '17.5', '', 'code_2', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('46081a34630c4', 'admin', '', '', '', '0', '2007-03-26 23:08:36', '127.0.0.1', 'code_after_update', 'TEXT', '', 'text', '~100px', '', '16.5', '', 'code_2', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('46081a3630c30', 'admin', '', '', '', '0', '2007-03-26 23:08:38', '127.0.0.1', 'code_before_add', 'TEXT', '', 'text', '~100px', '', '14.5', '', 'code_2', '0', 'sbs_wp_u15_dataobjects', '');
INSERT INTO u15_do_fields VALUES ('460ad2058ace5', 'admin', '', '', '', '0', '2007-03-29 00:37:25', '127.0.0.1', 'timeout', 'CHAR', '4', 'string', '', '', '13', '', 'cfg_timeout', '', 'sbs_wp_u15_templates', '');
INSERT INTO u15_do_fields VALUES ('47d7aa5d8c7c6', 'admin', '', '', '', '0', '2008-03-12 13:03:09', '127.0.0.1', 'descr', 'VARCHAR', '255', 'string', '', '_LNG_U15_DESCR_', '12', '', 'fields_descr', '', 'sbs_wp_u15_do_fields', '');
# --------------------------------------------------------

#
# Table structure for table `u15_filters`
#

CREATE TABLE u15_filters (
  id varchar(30) NOT NULL default '',
  uid varchar(15) NOT NULL default '',
  gid_r varchar(10) NOT NULL default '',
  gid_w varchar(10) NOT NULL default '',
  gid_i varchar(10) NOT NULL default '',
  parent_id varchar(30) NOT NULL default '0',
  _date datetime NOT NULL default '0000-00-00 00:00:00',
  host varchar(15) NOT NULL default '',
  title varchar(100) NOT NULL default '',
  _fields text NOT NULL,
  PRIMARY KEY  (id),
  KEY id (id)
) TYPE=MyISAM;

#
# Dumping data for table `u15_filters`
#

INSERT INTO u15_filters VALUES ('sbs_wp_u15_do_select', 'admin', '', '', '', '0', '2006-08-16 12:40:45', '127.0.0.1', 'U15: For dataobject fields', 'do_id|=|select|_LNG_U15_DOID_|sbs_wp_u15_dataobjects~sbs_wp_u15_select_do_1');
# --------------------------------------------------------

#
# Table structure for table `u15_templates`
#

CREATE TABLE u15_templates (
  id varchar(30) NOT NULL default '',
  uid varchar(15) NOT NULL default '',
  gid_r varchar(10) NOT NULL default '',
  gid_w varchar(10) NOT NULL default '',
  gid_i varchar(10) NOT NULL default '',
  parent_id varchar(30) NOT NULL default '0',
  _date datetime NOT NULL default '0000-00-00 00:00:00',
  host varchar(15) NOT NULL default '',
  title varchar(255) NOT NULL default '',
  tmpl_record_cell text NOT NULL,
  tmpl_record_cell_empty text NOT NULL,
  cell_divider text NOT NULL,
  row_divider text NOT NULL,
  record_on_row varchar(6) NOT NULL default '',
  record_on_page varchar(6) NOT NULL default '',
  record_order varchar(100) NOT NULL default '',
  table_header text NOT NULL,
  sql_fields varchar(255) NOT NULL default '',
  sql_join_suffix varchar(255) NOT NULL default '',
  sql_where_suffix varchar(255) NOT NULL default '',
  timeout varchar(4) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY id (id)
) TYPE=MyISAM;

#
# Dumping data for table `u15_templates`
#

INSERT INTO u15_templates VALUES ('sbs_wp_u15_parent_select', 'admin', '', '', '', '0', '2006-07-18 11:43:54', '127.0.0.1', 'Built-in template for selecting of parent record', '$tmp1 = \'\';\r\nfor ($N=0;$N<$level;$N++) $tmp1 .= \'-\';\r\n$this->record_cell = \'<option value="\'.$record->id.\'"\'.($GLOBALS[\'record\'][\'parent_id\']==$record->id?\' selected\':\'\').\'>\'.$tmp1.\' \'.$mobj->DB_result($R,$I,$this->parentid_field).\' (ID \'.$record->id.\')</option>\';', '\'\'', '\'\'', '\'\'', '1', '10000', '\'id\'', '', '\'*\'', '', '', '');
INSERT INTO u15_templates VALUES ('sbs_wp_u15_obj_list', 'admin', '', '', '', '0', '2006-07-18 11:46:11', '127.0.0.1', 'Built-in template: list of dataobjects in "select"', '$this->record_cell = \'\r\n<option value="\'.$record->id.\'"\'.($record->id==$GLOBALS[\'dataobject_id\']?\' selected\':\'\').\'>\'.$record->title.\'</option>\r\n\';', '\'\'', '\'\'', '\'\'', '1', '1000', '\'title\'', '', '\'*\'', '', '', '');
INSERT INTO u15_templates VALUES ('sbs_wp_u15_default', 'admin', '', '', '', '0', '2006-07-18 11:47:13', '127.0.0.1', 'Common template', '', '', '', '', '', '', '', '', '', '', '', '');
INSERT INTO u15_templates VALUES ('admin_sbs_wp_u15_templates', 'admin', '', '', '', '0', '2006-07-18 11:49:41', '127.0.0.1', 'Web-administrator of "U15 Templates"', '$this->record_cell = \'\r\n	<tr>\r\n	<td>\'.$record->id.\'</td>\r\n	<td>\'.$record->title.\'</td>\r\n	<td>\r\n\';\r\nif ($mobj->check_authority($record->gid_w, $record->uid))\r\n  $this->record_cell .= \'\r\n	<a href="\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&amode=edit_record&u15id=\'.$record->id.\'&order=\'.$GLOBALS[\'order\'].\'&page=\'.$GLOBALS[\'page\'].$GLOBALS[\'filter_url_suf\'].\'" title="\'._LNG_U15_T1_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_edit.gif" alt="\'._LNG_U15_T1_.\'" /></a>\r\n	<a href="javascript:if (window.confirm(\\\'\'._LNG_U15_SURE_.\'?\\\')) window.location.href=\\\'\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&u15delete_record=1&u15id=\'.$record->id.\'&order=\'.$GLOBALS[\'order\'].\'&page=\'.$GLOBALS[\'page\'].$GLOBALS[\'filter_url_suf\'].\'\\\'; else void(null);" title="\'._LNG_U15_T2_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_del.gif" alt="\'._LNG_U15_T2_.\'" /></a>\r\n<a href="\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&u15copy_record=1&u15id=\'.$record->id.\'&order=\'.$GLOBALS[\'order\'].\'&page=\'.$GLOBALS[\'page\'].$GLOBALS[\'filter_url_suf\'].\'" title="\'._LNG_U15_T3_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_copy.gif" alt="\'._LNG_U15_T3_.\'" /></a>\r\n  \';\r\nif ($mobj->check_authority(\'\', $record->uid))\r\n  $this->record_cell .= \'\r\n	<a href="javascript:window.open(\\\'\'._MOBJ_I_.\'?mmm=u0/cp/attributes&table=\'.$this->_table.\'&id=\'.$record->id.\'&attrs=i\\\',\\\'Attributes\\\',\\\'scrollbars=no,left=\\\'+(screen.width-350)/2+\\\',top=30,width=350,height=200\\\'); void(null);" title="\'._LNG_U00_ATTR_HINT1_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_attr.gif" alt="\'._LNG_U00_ATTR_HINT1_.\'" /></a>\r\n  \';\r\n$this->record_cell .= \'\r\n</td>\r\n</tr>\r\n\';\r\n', '\'\'', '\'\'', '\'\'', '1', '30', '\'id\'', '\'id|ID#title|\'._LNG_U15_CFGTITLE_.\'#|\'', '\'*\'', '', '', '');
INSERT INTO u15_templates VALUES ('admin_sbs_wp_u15_filters', 'admin', '', '', '', '0', '2006-07-18 11:50:32', '127.0.0.1', 'Web-administrator of "U15 Filters"', '$this->record_cell = \'\r\n	<tr>\r\n	<td>\'.$record->id.\'</td>\r\n	<td>\'.$record->title.\'</td>\r\n	<td>\r\n\';\r\nif ($mobj->check_authority($record->gid_w, $record->uid))\r\n  $this->record_cell .= \'\r\n	<a href="\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&amode=edit_record&u15id=\'.$record->id.\'" title="\'._LNG_U15_T1_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_edit.gif" alt="\'._LNG_U15_T1_.\'" /></a>\r\n<a href="javascript:if (window.confirm(\\\'\'._LNG_U15_SURE_.\'?\\\')) window.location.href=\\\'\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&u15delete_record=1&u15id=\'.$record->id.\'\\\'; else void(null);" title="\'._LNG_U15_T2_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_del.gif" alt="\'._LNG_U15_T2_.\'" /></a>\r\n  \';\r\nif ($mobj->check_authority(\'\', $record->uid))\r\n  $this->record_cell .= \'\r\n	<a href="javascript:window.open(\\\'\'._MOBJ_I_.\'?mmm=u0/cp/attributes&table=\'.$this->_table.\'&id=\'.$record->id.\'\\\',\\\'Attributes\\\',\\\'scrollbars=no,left=\\\'+(screen.width-350)/2+\\\',top=30,width=350,height=200\\\'); void(null);" title="\'._LNG_U00_ATTR_HINT1_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_attr.gif" alt="\'._LNG_U00_ATTR_HINT1_.\'" /></a>\r\n  \';\r\n$this->record_cell .= \'\r\n</td>\r\n</tr>\r\n\';\r\n', '\'\'', '\'\'', '\'\'', '1', '25', '\'id\'', '\'id|ID#title|Title#|\'', '\'*\'', '', '', '');
INSERT INTO u15_templates VALUES ('admin_sbs_wp_u15_do_fields', 'admin', '', '', '', '0', '2006-08-16 12:28:00', '127.0.0.1', 'Web-administrator of "U15 Dataobject fields"', '$this->record_cell = \'\r\n	<tr>\r\n	<td>\'.$record->_name.\'</td>\r\n	<td>\'.$record->_type.\'</td>\r\n	<td>\'.$record->_length.\'</td>\r\n	<td>\'.$record->itype.\'</td>\r\n	<td>\'.$record->add_params.\'</td>\r\n	<td>\'.$record->ititle.\'</td>\r\n	<td>\'.$record->inumber.\'</td>\r\n	<td>\'.$record->_gid_r.\'</td>\r\n	<td>\'.$record->help_id.\'</td>\r\n	<td>\'.$record->_index.\'</td>\r\n	<td>\r\n\';\r\nif ($mobj->check_authority($record->gid_w, $record->uid))\r\n  $this->record_cell .= \'\r\n	<a href="\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&amode=edit_record&u15id=\'.$record->id.\'&order=\'.$GLOBALS[\'order\'].\'&page=\'.$GLOBALS[\'page\'].$GLOBALS[\'filter_url_suf\'].\'" title="\'._LNG_U15_T1_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_edit.gif" alt="\'._LNG_U15_T1_.\'" /></a>\r\n	<a href="javascript:if (window.confirm(\\\'\'._LNG_U15_SURE_.\'?\\\')) window.location.href=\\\'\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&u15delete_record=1&u15id=\'.$record->id.\'&order=\'.$GLOBALS[\'order\'].\'&page=\'.$GLOBALS[\'page\'].$GLOBALS[\'filter_url_suf\'].\'\\\'; else void(null);" title="\'._LNG_U15_T2_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_del.gif" alt="\'._LNG_U15_T2_.\'" /></a>\r\n	<a href="\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&u15copy_record=1&u15id=\'.$record->id.\'&order=\'.$GLOBALS[\'order\'].\'&page=\'.$GLOBALS[\'page\'].$GLOBALS[\'filter_url_suf\'].\'" title="\'._LNG_U15_T3_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_copy.gif" alt="\'._LNG_U15_T3_.\'" /></a>\r\n  \';\r\nif ($mobj->check_authority(\'\', $record->uid))\r\n  $this->record_cell .= \'\r\n	<a href="javascript:window.open(\\\'\'._MOBJ_I_.\'?mmm=u0/cp/attributes&table=\'.$this->_table.\'&id=\'.$record->id.\'&attrs=i\\\',\\\'Attributes\\\',\\\'scrollbars=no,left=\\\'+(screen.width-350)/2+\\\',top=30,width=350,height=200\\\'); void(null);" title="\'._LNG_U00_ATTR_HINT1_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_attr.gif" alt="\'._LNG_U00_ATTR_HINT1_.\'" /></a>\r\n  \';\r\n$this->record_cell .= \'\r\n</td>\r\n</tr>\r\n\';', '\'\'', '\'\'', '\'\'', '1', '50', '\'inumber\'', '\'title|\'._LNG_U15_NAME_.\'#_type|\'._LNG_U15_TYPE_.\'#_length|\'._LNG_U15_LENGTH_.\'#itype|\'._LNG_U15_INTTYPE_.\'#add_params|\'._LNG_U15_ADDPARAMS_.\'#ititle|\'._LNG_U15_INTTITLE_.\'#inumber|\'._LNG_U15_INTNO_.\'#_gid_r|\'._LNG_U15_GIDR_.\'#help_id|\'._LNG_U15_HELPID_.\'#_index|\'._LNG_U15_INDEX_.\'#|\'', '\'*\'', '', '', '');
INSERT INTO u15_templates VALUES ('admin_sbs_wp_u15_dataobjects', 'admin', '', '', '', '0', '2006-08-16 14:47:39', '127.0.0.1', 'Web-administrator of "U15 Dataobjects"', '$this->record_cell = \'\r\n	<tr>\r\n	<td>\'.$record->title.\'</td>\r\n	<td>\'.$record->id.\'</td>\r\n	<td>\'.$record->_table.\'</td>\r\n	<td>\r\n\';\r\nif ($mobj->check_authority($record->gid_w, $record->uid))\r\n  $this->record_cell .= \'\r\n	<a href="\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&amode=edit_record&u15id=\'.$record->id.\'&order=\'.$GLOBALS[\'order\'].\'&page=\'.$GLOBALS[\'page\'].$GLOBALS[\'filter_url_suf\'].\'" title="\'._LNG_U15_T1_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_edit.gif" alt="\'._LNG_U15_T1_.\'" /></a>\r\n	<a href="javascript:if (window.confirm(\\\'\'._LNG_U15_SURE_.\'?\\\')) window.location.href=\\\'\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&u15delete_record=1&u15id=\'.$record->id.\'&order=\'.$GLOBALS[\'order\'].\'&page=\'.$GLOBALS[\'page\'].$GLOBALS[\'filter_url_suf\'].\'\\\'; else void(null);" title="\'._LNG_U15_T2_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_del.gif" alt="\'._LNG_U15_T2_.\'" /></a>\r\n	<a href="\'._MOBJ_I_.\'?mmm=\'.$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.$GLOBALS[\'dataobject_id\'].\'&u15copy_record=1&u15id=\'.$record->id.\'&order=\'.$GLOBALS[\'order\'].\'&page=\'.$GLOBALS[\'page\'].$GLOBALS[\'filter_url_suf\'].\'" title="\'._LNG_U15_T3_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_copy.gif" alt="\'._LNG_U15_T3_.\'" /></a>\r\n  \';\r\nif ($mobj->check_authority(\'\', $record->uid))\r\n  $this->record_cell .= \'\r\n	<a href="javascript:window.open(\\\'\'._MOBJ_I_.\'?mmm=u0/cp/attributes&table=\'.$this->_table.\'&id=\'.$record->id.\'&attrs=i\\\',\\\'Attributes\\\',\\\'scrollbars=no,left=\\\'+(screen.width-350)/2+\\\',top=30,width=350,height=200\\\'); void(null);" title="\'._LNG_U00_ATTR_HINT1_.\'"><img src="\'._MOBJ_THEMES_FOLDER_.$mobj->decor_folder.\'pics/icon_attr.gif" alt="\'._LNG_U00_ATTR_HINT1_.\'" /></a>\r\n  \';\r\n$this->record_cell .= \'\r\n</td>\r\n</tr>\r\n\';\r\n', '\'\'', '\'\'', '\'\'', '1', '50', '\'title\'', '\'title|Title#id|ID#_table|Table name#|\'', '\'*\'', '', '', '');
INSERT INTO u15_templates VALUES ('sbs_wp_u15_select_do_1', 'admin', '', '', '', '0', '2006-08-16 23:28:12', '127.0.0.1', 'For select dataobject in fields of dataobjects', '$this->record_cell = \'\r\n<option value="\'.$record->id.\'"\'.($record->id==$GLOBALS[\'filter_fields\'][\'do_id\']?\' selected\':\'\').\'>\'.$record->title.\'</option>\r\n\';', '\'\'', '\'\'', '\'\'', '1', '1000', '\'title\'', '', '', '', '', '');
INSERT INTO u15_templates VALUES ('sbs_wp_u15_select_do_2', 'admin', '', '', '', '0', '2006-08-18 10:30:30', '127.0.0.1', 'For select dataobject in fields of dataobjects', '$this->record_cell = \'\r\n<option value="\'.$record->id.\'"\'.($record->id==$GLOBALS[\'record\'][\'do_id\']?\' selected\':\'\').\'>\'.$record->title.\'</option>\r\n\';', '\'\'', '\'\'', '\'\'', '1', '1000', '\'title\'', '', '', '', '', '');
INSERT INTO u15_templates VALUES ('sbs_wp_u15_filter_list', 'admin', '', '', '', '0', '2007-03-27 16:06:43', '127.0.0.1', 'Built-in template: list of filters in "select"', '$this->record_cell = \'\r\n<option value="\'.$record->id.\'"\'.($record->id==$GLOBALS[\'record\'][\'filter_id\']?\' selected\':\'\').\'>\'.$record->title.\'</option>\r\n\';', '\'\'', '\'\'', '\'\'', '1', '1000', '\'title\'', '', '', '', '', '');

    

