<?php
load_lng('u15/');

// Main class of module U15
class U15 {
  function U15($cfg_name = '')
  {
    global $mobj;

    $this->column_types = array(
      'TINYINT',
      'SMALLINT',
      'MEDIUMINT',
      'INT',
      'BIGINT',
      'FLOAT',
      'DOUBLE',
      'DECIMAL',
      'DATE',
      'DATETIME',
      'TIMESTAMP',
      'TIME',
      'YEAR',
      'CHAR',
      'VARCHAR',
      'TINYBLOB',
      'TINYTEXT',
      'TEXT',
      'BLOB',
      'MEDIUMBLOB',
      'MEDIUMTEXT',
      'LONGBLOB',
      'LONGTEXT',
      'ENUM',
      'SET'
    );
    $this->inttypes = array('string', 'text', 'wysiwyg', 'datetime', 'checkbox', 'radio', 'select', 'file', 'picture', 'list', 'hidden', 'url', 'password', 'file_text');
    $this->protocols = array('http://', 'shttp://', 'mailto:', 'ftp://');
    $this->id_types = array(0=>'Integer', 1=>'Varchar');

    // Default
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u15_templates where id='sbs_wp_u15_default'";
    $R = $mobj->DB_db_query();
    $tmp = $mobj->DB_fetch_assoc($R);
    foreach ($tmp as $field=>$val) {
      if (trim($val) == '') eval('$this->'.$field.' = "";');
      if ($field == 'tmpl_record_row') $this->tmpl_record_row = $val;
      elseif ($field == 'tmpl_record_cell') $this->tmpl_record_cell = $val;
      elseif ($field == 'table_header') $this->table_header = $val;
      elseif (!empty($val) and !in_array($field, array('id','uid','gid_r','gid_w','gid_i','parent_id','_date','host','title'))) eval('$this->'.$field.' = '.$val.';');
    }
    // Special if specified
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u15_templates where id='$cfg_name'";
    $R = $mobj->DB_db_query();
    if ($mobj->DB_num_rows($R) > 0) {
      $tmp = $mobj->DB_fetch_assoc($R);
      foreach ($tmp as $field=>$val) {
        if ($val != '-1') {
          if (trim($val) == '') eval('$this->'.$field.' = "";');
          elseif ($field == 'tmpl_record_row') $this->tmpl_record_row = $val;
          elseif ($field == 'tmpl_record_cell') $this->tmpl_record_cell = $val;
          elseif ($field == 'table_header') $this->table_header = $val;
          elseif (!empty($val) and !in_array($field, array('id','uid','gid_r','gid_w','gid_i','parent_id','_date','host','title'))) eval('$this->'.$field.' = '.$val.';');
        }
      }
    }
  }

  // Creates a dataobject
  // Out: 0 if succesfully created, 1 if user denied
  function u15create_dataobject($dataobject_id, $title, $_table, $id_type)
  {
    global $mobj;
    if (!$mobj->check_authority('0')) return 1;

    if (!is_numeric($id_type)) $id_type = 0;
    $mobj->SQL = "CREATE TABLE "._MOBJ_DB_TPREF_."$_table (
      id ".($id_type==1?"varchar(30)":"int(11)")." NOT NULL ".($id_type==1?"default '0'":"AUTO_INCREMENT").",
      uid varchar(15) NOT NULL default '',
      gid_r varchar(10) NOT NULL default '',
      gid_w varchar(10) NOT NULL default '',
      gid_i varchar(10) NOT NULL default '',
      parent_id ".($id_type==1?"varchar(30)":"int(11)")." NOT NULL default '0',
      _date datetime NOT NULL default '0000-00-00 00:00:00',
      host varchar(15) NOT NULL default '',
      PRIMARY KEY  (id),
      KEY id (id)
      ) TYPE=MyISAM;";
    $mobj->DB_db_query();

    // Inserting a default template
    if ($dataobject_id == '') $dataobject_id = uniqid('');
    $mobj->SQL = "INSERT INTO "._MOBJ_DB_TPREF_."u15_templates VALUES('admin_$dataobject_id', '".$_SESSION[pers_set][id]."', '', '', '', '0', '".date('Y-m-d H:i:s')."','".Get_IP()."', 'Web-administrator of \"$title\"', 
'
\$this->record_cell = \'
	<tr>
	<td>\'.\$record->id.\'</td>
	<td>
\';
if (\$mobj->check_authority(\$record->gid_w, \$record->uid))
  \$this->record_cell .= \'
	<a href=\"\'._MOBJ_I_.\'?mmm=\'.\$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.\$GLOBALS[\'dataobject_id\'].\'&amode=edit_record&u15id=\'.\$record->id.\'&order=\'.\$GLOBALS[\'order\'].\'&page=\'.\$GLOBALS[\'page\'].\$GLOBALS[\'filter_url_suf\'].\'\" title=\"\'._LNG_U15_T1_.\'\"><img src=\"\'._MOBJ_THEMES_FOLDER_.\$mobj->decor_folder.\'pics/icon_edit.gif\" alt=\"\'._LNG_U15_T1_.\'\" /></a>
	<a href=\"javascript:if (window.confirm(\\\\\'\'._LNG_U15_SURE_.\'?\\\\\')) window.location.href=\\\\\'\'._MOBJ_I_.\'?mmm=\'.\$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.\$GLOBALS[\'dataobject_id\'].\'&u15delete_record=1&u15id=\'.\$record->id.\'&order=\'.\$GLOBALS[\'order\'].\'&page=\'.\$GLOBALS[\'page\'].\$GLOBALS[\'filter_url_suf\'].\'\\\\\\'; else void(null);\" title=\"\'._LNG_U15_T2_.\'\"><img src=\"\'._MOBJ_THEMES_FOLDER_.\$mobj->decor_folder.\'pics/icon_del.gif\" alt=\"\'._LNG_U15_T2_.\'\" /></a>
	<a href=\"\'._MOBJ_I_.\'?mmm=\'.\$GLOBALS[\'admin_mmm\'].\'&dataobject_id=\'.\$GLOBALS[\'dataobject_id\'].\'&u15copy_record=1&u15id=\'.\$record->id.\'&order=\'.\$GLOBALS[\'order\'].\'&page=\'.\$GLOBALS[\'page\'].\$GLOBALS[\'filter_url_suf\'].\'\" title=\"\'._LNG_U15_T3_.\'\"><img src=\"\'._MOBJ_THEMES_FOLDER_.\$mobj->decor_folder.\'pics/icon_copy.gif\" alt=\"\'._LNG_U15_T3_.\'\" /></a>
  \';
if (\$mobj->check_authority(\'\', \$record->uid))
  \$this->record_cell .= \'
	<a href=\"javascript:window.open(\\\\\'\'._MOBJ_I_.\'?mmm=u0/cp/attributes&table=\'.\$this->_table.\'&id=\'.\$record->id.\'&attrs=i\\\\\',\\\\\'Attributes\\\\\',\\\\\'scrollbars=no,left=\\\\\'+(screen.width-350)/2+\\\\\',top=30,width=350,height=200\\\\\'); void(null);\" title=\"\'._LNG_U00_ATTR_HINT1_.\'\"><img src=\"\'._MOBJ_THEMES_FOLDER_.\$mobj->decor_folder.\'pics/icon_attr.gif\" alt=\"\'._LNG_U00_ATTR_HINT1_.\'\" /></a>
  \';
\$this->record_cell .= \'
</td>
</tr>
\';
', '\'\'', '\'\'', '\'\'', '1', '25', '\'_date desc\'', '\'id|ID#|\'', '\'*\'', '', '', '60')";
    $mobj->DB_db_query();
  }

  // Deletes a dataobject
  // Out: 1 if user denied
  function u15delete_dataobject($id)
  {
    global $mobj;
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u15_dataobjects where id='$id'";
    $R = $mobj->DB_db_query();
    if (!$mobj->check_authority($mobj->DB_result($R,0,'gid_w'),$mobj->DB_result($R,0,'uid'))) return 1;

    $dataobject = new U15_1($id, 'admin_'.$id);
    $dataobject->u15delete_all_records();

    $mobj->SQL = "DELETE FROM "._MOBJ_DB_TPREF_."u15_do_fields WHERE do_id='$id'";
    $mobj->DB_db_query();
    $mobj->SQL = "DROP TABLE "._MOBJ_DB_TPREF_.$mobj->DB_result($R,0,'_table')."";
    $mobj->DB_db_query();
    $mobj->SQL = "DELETE FROM "._MOBJ_DB_TPREF_."u15_templates WHERE id='admin_$id'";
    $mobj->DB_db_query();
    return 0;
  }

  // Updates a dataobject
  // Out: 1 if user denied
  function u15update_dataobject($id, $_table, $new_id)
  {
    global $mobj;
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u15_dataobjects where id='$id'";
    $R = $mobj->DB_db_query();
    if (!$mobj->check_authority($mobj->DB_result($R,0,'gid_w'),$mobj->DB_result($R,0,'uid'))) return 1;

    // Preventing of renaming to existing table
    if (_MOBJ_DB_TPREF_.$mobj->DB_result($R, 0, '_table') != $_table) {
      $Rtables = $mobj->DB_list_tables($mobj->DB);
      for ($I=0; $I<$mobj->DB_num_rows($Rtables); $I++)
        if ($mobj->DB_result($Rtables,$I) == $_table) return 2;
    }

    $mobj->SQL = "ALTER TABLE `"._MOBJ_DB_TPREF_.$mobj->DB_result($R, 0, '_table')."` RENAME `$_table`";
    $mobj->DB_db_query();

    // When changing ID of dataobject
    $mobj->SQL = "update "._MOBJ_DB_TPREF_."u15_templates set id='admin_$new_id' where id='admin_$id'";
    $mobj->DB_db_query();
    $mobj->SQL = "update "._MOBJ_DB_TPREF_."u15_do_fields set do_id='$new_id' where do_id='$id'";
    $mobj->DB_db_query();
    return 0;
  }

  // Returns a table header for web-administrator
  function u15get_table_header()
  {
    global $tmpl_sort, $order;
    preg_match("/^'(.*?)'$/", $this->table_header, $tmp); // Cutting "'"
    $tmp1 = explode('#', $tmp[1]);
    foreach ($tmp1 as $val) {
      $tmp2 = explode('|',$val);
      if ($tmp2[0]) {
        eval('$tmp3 = \''.$tmp2[1].'\';');
        $out .= '<th>'.$tmp3.'<br />'.get_sort_block($tmp2[0], $tmpl_sort, $order).'</th>';
      } else $out .= '<th>&nbsp;</th>';
    }
    return $out;
  }
}

// Class of dataobject
class U15_1 extends U15 {
  function U15_1($id, $cfg_name = '')
  {
    global $mobj;
    parent::U15($cfg_name);
    $this->id = $id;

    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u15_dataobjects where id='".$this->id."'";
    $R = $mobj->DB_db_query();

    if ($this->sql_fields == '') $this->sql_fields = '*';

    $this->gid_rm = $mobj->DB_result($R, 0, 'gid_rm');
    $this->gid_wm = $mobj->DB_result($R, 0, 'gid_wm');
    $this->gid_im = $mobj->DB_result($R, 0, 'gid_im');

    // Used in adding of records of dataobject
    $this->uid = $mobj->DB_result($R, 0, 'uid');
    $this->gid_r = $mobj->DB_result($R, 0, 'gid_r');
    $this->gid_w = $mobj->DB_result($R, 0, 'gid_w');
    $this->gid_i = $mobj->DB_result($R, 0, 'gid_i');

    $this->code_before = $mobj->DB_result($R, 0, 'code_before');
    $this->code_after = $mobj->DB_result($R, 0, 'code_after');
    $this->code_before_add = $mobj->DB_result($R, 0, 'code_before_add');
    $this->code_after_add = $mobj->DB_result($R, 0, 'code_after_add');
    $this->code_before_delete = $mobj->DB_result($R, 0, 'code_before_delete');
    $this->code_after_delete = $mobj->DB_result($R, 0, 'code_after_delete');
    $this->code_before_update = $mobj->DB_result($R, 0, 'code_before_update');
    $this->code_after_update = $mobj->DB_result($R, 0, 'code_after_update');
    $this->editable_id = $mobj->DB_result($R, 0, 'editable_id');
    $this->id_type = $mobj->DB_result($R, 0, 'id_type');
    $this->_table = $mobj->DB_result($R, 0, '_table');
    $this->title = $mobj->DB_result($R, 0, 'title');
    $this->help_cfg = $mobj->DB_result($R, 0, 'help_cfg');
    $this->upload_folder = $mobj->DB_result($R, 0, 'upload_folder');
    $this->parentid_field = $mobj->DB_result($R, 0, 'parentid_field');
    $this->lng_files = $mobj->DB_result($R, 0, 'lng_files');
    $this->filter_id = $mobj->DB_result($R, 0, 'filter_id');
    $this->_index = $mobj->DB_result($R, 0, '_index');

    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u15_do_fields where do_id='".$this->id."'";
    $Rfields = $mobj->DB_db_query();
    for ($I=0;$I<$mobj->DB_num_rows($Rfields);$I++) {
      $mobj->SQL = "SHOW FIELDS FROM `"._MOBJ_DB_TPREF_.$this->_table."` LIKE '".$mobj->DB_result($Rfields,$I,'_name')."'";
      $R1 = $mobj->DB_db_query();
      $tmp3 = $mobj->DB_fetch_array($R1);
      $type_a = explode('(', $tmp3[1]);
      $length_a = explode(')', $type_a[1]);
      $this->fields[$I][type] = strtoupper($type_a[0]);
      $this->fields[$I][length] = strtoupper($length_a[0]);

      $this->fields[$I][field]	= $mobj->DB_result($Rfields,$I,'_name');
      $this->fields[$I][type]	= $mobj->DB_result($Rfields,$I,'_type');
      $this->fields[$I][length]	= $mobj->DB_result($Rfields,$I,'_length');
      $this->fields[$I][inttype]	= $mobj->DB_result($Rfields,$I,'itype');
      $this->fields[$I][inttitle]	= $mobj->DB_result($Rfields,$I,'ititle');
      $this->fields[$I][intno]	= $mobj->DB_result($Rfields,$I,'inumber');
      $this->fields[$I][gidr]	= $mobj->DB_result($Rfields,$I,'_gid_r');
      $this->fields[$I][helpid]	= $mobj->DB_result($Rfields,$I,'help_id');
      $this->fields[$I][addparams]	= $mobj->DB_result($Rfields,$I,'add_params');
      $this->fields[$I][_index]		= $mobj->DB_result($Rfields,$I,'_index');
    }
  }

  // Return quantity of records
  function u15get_records_quantity($parent_id = '0', $chk_perm = '', $add_sql_suf = '')
  {
    global $mobj;

    if (!$parent_id) $parent_id = '0';
    $suf = " where parent_id='$parent_id'";

    // Checking of permission
    if ($chk_perm!='' and ($_SESSION[pers_set][ug]!='0'))
      $suf .= (empty($suf)?' where ':' and ')."(gid_$chk_perm='*'
        ".($_SESSION[pers_set][ug]==''?"":" or gid_$chk_perm like '%".$_SESSION[pers_set][ug]."%'")." or (uid!='' and uid='".$_SESSION[pers_set][id]."' and gid_$chk_perm not like '%-%'))";

    // Anti SQL-injection
    if (preg_match ("/;( *?)(insert|delete|select|create|drop) /", $add_sql_suf)) $add_sql_suf = '';

    if ($add_sql_suf) $suf .= (empty($suf)?' where ':' and ')."($add_sql_suf)";

    $mobj->SQL = "select id from "._MOBJ_DB_TPREF_.$this->_table.$suf;
    $R = $mobj->DB_db_query();
    $out->quantity = $mobj->DB_num_rows($R);
    for ($I=0;$I<$mobj->DB_num_rows($R);$I++) {
      $tmp = $this->u15get_records_quantity($mobj->DB_result($R,$I,'id'), $chk_perm, $add_sql_suf);
      $out->quantity += $tmp->quantity;
    }
    return $out;
  }

  // Return list of records
  // $chk_perm: '' - any, 'r' - allowed to read, 'w' - allowed to write
  // $level - auxiliary, can be used in templates for various highlighting etc.
  // $wohierarchy - if TRUE records will be processed disregarding of hierarchy (use this for search records with "$add_sql_suf")
  function u15get_records($parent_id = '0', $page = 1, $chk_perm = '', $add_sql_suf = '', $wohierarchy = FALSE, $level = 0)
  {
    global $mobj;

    if (!$parent_id) $parent_id = '0';
    if (!is_numeric($page) or $page<1) $page = 1;

    if ($this->sql_join_suffix) $suf_join = " ".$this->sql_join_suffix;

    if ($this->sql_where_suffix) $suf .= (empty($suf)?' where ':' and ')."(".$this->sql_where_suffix.")";

    if (!$wohierarchy) $suf .= (empty($suf)?' where ':' and ')._MOBJ_DB_TPREF_.$this->_table.".parent_id='$parent_id'";

    // Anti SQL-injection
    if (preg_match ("/;( *?)(insert|delete|select|create|drop) /", $add_sql_suf)) $add_sql_suf = '';
    if (preg_match ("/;/", $this->record_order)) $this->record_order = '';

    if ($add_sql_suf) $suf .= (empty($suf)?' where ':' and ')."($add_sql_suf)";

    // Checking of permission
    if ($chk_perm!='' and ($_SESSION[pers_set][ug]!='0'))
      $suf .= (empty($suf)?' where ':' and ')."("._MOBJ_DB_TPREF_.$this->_table.".gid_$chk_perm='*'
        ".($_SESSION[pers_set][ug]==''?"":" or "._MOBJ_DB_TPREF_.$this->_table.".gid_$chk_perm like '%".$_SESSION[pers_set][ug]."%'")." or ("._MOBJ_DB_TPREF_.$this->_table.".uid!='' and "._MOBJ_DB_TPREF_.$this->_table.".uid='".$_SESSION[pers_set][id]."' and "._MOBJ_DB_TPREF_.$this->_table.".gid_$chk_perm not like '%-%'))";

    $sql = " from "._MOBJ_DB_TPREF_.$this->_table.$suf_join.$suf;
    $mobj->SQL = "select count(*)$sql";
    $out->lq_record_q	= $mobj->DB_result($mobj->DB_db_query(), 0);
    $out->lq_start	= ($page-1) * $this->record_on_page + 1;
    $out->lq_end	= $out->lq_start + $this->record_on_page - 1;
    if ($out->lq_end > $out->lq_record_q) $out->lq_end = $out->lq_record_q;

    $mobj->SQL = "select ".$this->sql_fields."$sql order by ".$this->record_order." limit ".($out->lq_start-1).",".$this->record_on_page;
    $R = $mobj->DB_db_query();
    $row_q = ceil($mobj->DB_num_rows($R)/$this->record_on_row);
    if ($rows_q == 1) $this->record_on_row = $mobj->DB_num_rows($R);
    for ($I=0;$I<$mobj->DB_num_rows($R);) {
      for ($J=0;$J<$this->record_on_row;$J++){
        $line_number = ($page - 1) * $this->record_on_page + $I + 1; // Auxiliary: only for external use

        if ($I < $mobj->DB_num_rows($R)) {
          $record = $mobj->DB_fetch_object($R);
          eval($this->tmpl_record_cell);
          $out->HTML_records .= $this->record_cell;
        } else $out->HTML_records .= $this->tmpl_record_cell_empty;
        if ($J < $this->record_on_row - 1) $out->HTML_records .= $this->cell_divider;
        $I++;
      }

      if (!$wohierarchy) {
        // Sublevels
        $tmp = $this->u15get_records($record->id, $page, $chk_perm, $add_sql_suf, $wohierarchy, $level + 1);
        $out->HTML_records .= $tmp->HTML_records;
        $out->lq_record_q += $tmp->lq_record_q;
      }

      if ($I < $mobj->DB_num_rows($R)) $out->HTML_records .= $this->row_divider;
    }
    return $out;
  }

  // Return data of record
  // If $id = 'random' return random record
  function u15get_record($id = 'random', $chk_perm = '', $out_type = '0', $add_sql_suf = '')
  {
    global $mobj;

    // Checking of permission
    if ($chk_perm!='' and ($_SESSION[pers_set][ug]!='0'))
      $suf .= (empty($suf)?' where ':' and ')."(gid_$chk_perm='*'
        ".($_SESSION[pers_set][ug]==''?"":" or gid_$chk_perm like '%".$_SESSION[pers_set][ug]."%'")."
        or (uid!='' and uid='".$_SESSION[pers_set][id]."' and gid_$chk_perm not like '%-%'))";

    // Anti SQL-injection
    if (preg_match ("/;( *?)(insert|delete|select|create|drop) /", $add_sql_suf)) $add_sql_suf = '';

    if ($add_sql_suf) $suf .= (empty($suf)?' where ':' and ')."($add_sql_suf)";

    if ($id == 'random') {
      $mobj->SQL = "select id from "._MOBJ_DB_TPREF_.$this->_table."$suf";
      $R = $mobj->DB_db_query();
      srand ((double) microtime() * 1000000);
      $id = $mobj->DB_result($R, rand(0,$mobj->DB_num_rows($R)-1));
    }

    if ($id != '') $suf .= (empty($suf)?' where ':' and ')."id='$id'";
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_.$this->_table."$suf";
    $R = $mobj->DB_db_query();
    if ($mobj->DB_num_rows($R) > 0) {
      if ($out_type == 1) $data = $mobj->DB_fetch_array($R);
      else $data = $mobj->DB_fetch_object($R);
      return $data;
    } else return FALSE;
  }

  // Addes a record
  // Out: 0 if succesfully added, 1 if user denied, 2 if this ID exists,
  // 3 if timeout has not passed
  function u15add_record($fields)
  {
    global $mobj;

    if (!$mobj->check_authority('0')) { // Checking timeout
      $mobj->SQL = "select _date from "._MOBJ_DB_TPREF_.$this->_table." where host='".Get_IP()."' order by _date desc limit 1";
      if ($this->timeout == '') $this->timeout = 0;
      if (strtotime("-".$this->timeout." seconds") <= (strtotime($mobj->DB_result($mobj->DB_db_query(), 0)))) return array('id'=>0, 'result'=>3);
    }

    if ($fields[parent_id]!='0' and $fields[parent_id]!='') { // Checking by field
      $mobj->SQL = "select * from "._MOBJ_DB_TPREF_.$this->_table." where id='".$fields[parent_id]."'";
      $R = $mobj->DB_db_query();
      if (!$mobj->check_authority($mobj->DB_result($R,0,'gid_i'),$mobj->DB_result($R,0,'uid'))) return array('id'=>0, 'result'=>1);
    } else { // Checking by dataobject
      if (!$mobj->check_authority($this->gid_i, $this->uid)) return array('id'=>0, 'result'=>1);
    }

    if ($fields[id]) $id = $fields[id];
    else {
      if ($this->id_type == 1) $id = uniqid(''); else $id = 0;
    }

    $mobj->SQL = "select id from "._MOBJ_DB_TPREF_.$this->_table." where id='$id'";
    if ($mobj->DB_num_rows($mobj->DB_db_query()) > 0) return array('id'=>0, 'result'=>2);

    if (!$fields[parent_id]) $fields[parent_id] = '0';

    $mobj->SQL = "insert into "._MOBJ_DB_TPREF_.$this->_table." (id, uid, gid_r, gid_w, gid_i, parent_id, _date, host) values('$id', '".$_SESSION[pers_set][id]."','".$this->gid_rm."','".$this->gid_wm."','".$this->gid_im."', '$fields[parent_id]', '".date('Y-m-d H:i:s')."','".Get_IP()."')";
    $R = $mobj->DB_db_query();

    if ($this->id_type!='1' and $fields[id]=='') $id = $mobj->DB_insert_id();

    unset($fields[id]);
    $this->u15update_additional_fields($id, $fields);

    $mobj->log_event(_LNG_U15_LOG4_.' (ID '.$id.')', $_SESSION[pers_set][id]);

/*
    // Sending E-mail message to support service
    if (!$adm_mode and $this->send_notice) {
      $this->add_notice_tmpl = '[MSG]';

      $mail_mes = str_replace(array('[MSG]'),
        array($record->id), $this->add_notice_tmpl);

      $mail = new Mail_sender;
      $mail->from_addr = $mobj->email_support;
      $mail->from_name = _MOBJ_URL_;
      $mail->to = $mobj->email_support;
      $mail->subj = $this->add_notice_subj;
      $mail->body_type = 'text/html';
      $mail->body = $mail_mes;
      $mail->priority = 3;
      $mail->prepare_letter();
      $mail->send_letter();
    }
*/
    return array('id'=>$id, 'result'=>0);
  }

  // Deletes a record
  // Out: 1 if user denied
  function u15delete_record($id)
  {
    global $mobj;
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_.$this->_table." where id='$id'";
    $R = $mobj->DB_db_query();
    if (!$mobj->check_authority($mobj->DB_result($R,0,'gid_w'),$mobj->DB_result($R,0,'uid'))) return 1;

    // Deleting of uploaded or attached files
    foreach ($this->fields as $I=>$val) {
      switch ($val[inttype]) {
        case 'file':
        case 'picture':
          $mobj->SQL = "select ".$val[field]." from "._MOBJ_DB_TPREF_.$this->_table." where id='$id'";
          $R = $mobj->DB_db_query();
          @unlink($this->upload_folder.$mobj->DB_result($R, 0));
          $fname = $this->u15split_picture_fname($mobj->DB_result($R, 0));
          @unlink($this->upload_folder.$fname[0].'_small1'.$fname[1]);
          @unlink($this->upload_folder.$fname[0].'_small2'.$fname[1]);
          @unlink($this->upload_folder.$fname[0].'_small3'.$fname[1]);
          break;
        case 'file_text':
          $mobj->SQL = "select ".$val[field]." from "._MOBJ_DB_TPREF_.$this->_table." where id='$id'";
          $R = $mobj->DB_db_query();
          @unlink($mobj->DB_result($R, 0));
          break;
      }
    }

    // Subrecords
    $mobj->SQL = "select id from "._MOBJ_DB_TPREF_.$this->_table." where parent_id='$id'";
      $R = $mobj->DB_db_query();
      if ($mobj->DB_num_rows($R) > 0)
        for ($I=0;$I<$mobj->DB_num_rows($R);$I++)
          $this->u15delete_record($mobj->DB_result($R,$I));

    $mobj->SQL = "delete from "._MOBJ_DB_TPREF_.$this->_table." where id='$id'";
    $mobj->DB_db_query();
    $mobj->log_event(_LNG_U15_LOG6_.' (ID '.$id.')', $_SESSION[pers_set][id]);
    return 0;
  }

  // Deletes all records in dataobject
  // Out: 1 if user denied
  function u15delete_all_records()
  {
    global $mobj;
    if (!$mobj->check_authority('0')) return 1;
    $mobj->SQL = "select id from "._MOBJ_DB_TPREF_.$this->_table;
    $R = $mobj->DB_db_query();
    for ($I=0;$I<$mobj->DB_num_rows($R);$I++)
      $this->u15delete_record($mobj->DB_result($R, $I));
    return 0;
  }

  // Copies a record
  // Out: 1 if user denied
  function u15copy_record($id)
  {
    global $mobj;

    $source_record = $this->u15get_record($id);
    unset($source_record->id);
    unset($source_record->_date);
    unset($source_record->host);
    $res = $this->u15add_record($source_record);
    if ($res['result'] == '1') return 1;
    else return 0;
  }

  // Updates a record
  // Out: 0 if succesfully updated, 1 if user denied
  function u15update_record($id, $fields)
  {
    global $mobj;
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_.$this->_table." where id='$id'";
    $R = $mobj->DB_db_query();
    if (!$mobj->check_authority($mobj->DB_result($R,0,'gid_w'),$mobj->DB_result($R,0,'uid'))) return 1;

    $this->u15update_additional_fields($id, $fields);

    $mobj->log_event(_LNG_U15_LOG5_.' (ID '.$id.')', $_SESSION[pers_set][id]);
    if ($res != 1) $res = 0;
    return $res;
  }

  // Updates additional (non-standard) fields
  function u15update_additional_fields($id, $fields)
  {
    global $mobj;

    if (get_magic_quotes_gpc()) $tmp_quotes = TRUE;
    $J = 0;

    if (is_array($_FILES[fields]))
      $fields = array_merge($fields, $_FILES[fields][tmp_name]); // Uploaded files

    foreach ($fields as $I=>$val) {
      if (!empty($suf)) $suf .= ',';

      for ($K=0;$K<count($this->fields);$K++) {
        if ($this->fields[$K][field] == $I) break;
      }

      $add_params = explode('~', $this->fields[$K][addparams]);

      switch ($this->fields[$K][inttype]) {
        case 'password':
          if ($val != '') {
            $val = md5($val);
          } else { // Leave w/o changes
            $mobj->SQL = "select $I from "._MOBJ_DB_TPREF_.$this->_table." where id='$id'";
            $val = $mobj->DB_result($mobj->DB_db_query(), 0);
          }
          break;
        case 'text':
          if ($add_params[2]) $val = strip_tags($val);
          break;
        case 'list':
          $val = @implode('###', $val);
          break;
        case 'datetime':
          $val = $val[date].' '.$val[time];
          break;
        case 'select':
          $val = @implode('###', $val);
          break;
        case 'file':
        case 'picture':
          $mobj->SQL = "select $I from "._MOBJ_DB_TPREF_.$this->_table." where id='$id'";
          $R = $mobj->DB_db_query();

          // Deleting
          if (is_uploaded_file($val) or $_POST[fields][$I][delete]) {
            @unlink($this->upload_folder.$mobj->DB_result($R, 0));
            $fname = $this->u15split_picture_fname($mobj->DB_result($R, 0));
            @unlink($this->upload_folder.$fname[0].'_small1'.$fname[1]);
            @unlink($this->upload_folder.$fname[0].'_small2'.$fname[1]);
            @unlink($this->upload_folder.$fname[0].'_small3'.$fname[1]);
          }

          if (is_uploaded_file($val)) {
// and $pic_sm_size<$this->pic_small_max_size and ($pic_sm_type=="image/gif" or $pic_sm_type=="image/jpeg" or $pic_sm_type=="image/pjpeg")) {
            // Getting a extension
            preg_match("/\.([^\.]*?)$/", $_FILES[fields][name][$I], $ext);
            $ext = strtolower($ext[0]);

            $pic_id = uniqid('');

            $add_params = explode('~', $this->fields[$K][addparams]);

            // Generating of preview pictures
            $tmp_no = array(1, 3, 4);
            foreach ($tmp_no as $tmp1=>$tmp_id) {
              if ($add_params[$tmp_id]>0 and function_exists('ImageCreateFromJPEG')) {
                $tmp = GetImageSize($val);
                if ($tmp[2] == 2) {
                  $image_big_id = ImageCreateFromJPEG($val);
                  $thn_width = $add_params[$tmp_id];
                  $thn_height = ImageSY($image_big_id)/(ImageSX($image_big_id)/$thn_width);
                  $image_thn_id = ImageCreateTrueColor($thn_width, $thn_height);
                  ImageCopyResampled($image_thn_id, $image_big_id, 0, 0, 0, 0, $thn_width, $thn_height, ImageSX($image_big_id), ImageSY($image_big_id));
                  ImageJPEG($image_thn_id, $this->upload_folder.$pic_id.'_small'.($tmp1+1).$ext);
                  @chmod($this->upload_folder.$pic_id.'_small'.($tmp1+1).$ext, 0777);
                }
              }
            }

            // Changing width of main picture
            if ($add_params[2]>0 and function_exists('ImageCreateFromJPEG')) {
              $tmp = GetImageSize($val);
              if ($tmp[2] == 2) {
                $img = ImageCreateFromJPEG($val);
                $thn_width = $add_params[2];
                $thn_height = ImageSY($img)/(ImageSX($img)/$thn_width);
                $image_thn_id = ImageCreateTrueColor($thn_width, $thn_height);
                ImageCopyResampled($image_thn_id, $img, 0, 0, 0, 0, $thn_width, $thn_height, ImageSX($img), ImageSY($img));
                ImageJPEG($image_thn_id, $val);
              }
            }
            // Making an inscription
            if (!empty($add_params[0]) and function_exists('ImageCreateFromJPEG')) {
              $tmp = GetImageSize($val);
              if ($tmp[2] == 2) {
                $img = ImageCreateFromJPEG($val);
                ImageFilledRectangle($img, ImageSX($img)-6*strlen($add_params[0])-8, ImageSY($img)-13, ImageSX($img)-4, ImageSY($img)-3, ImageColorAllocate($img, 255, 255, 255));
                ImageString($img, 2, ImageSX($img)-6*strlen($add_params[0])-5, ImageSY($img)-15, $add_params[0], ImageColorAllocate($img, 0, 0, 0));
                ImageJPEG($img, $val);
              }
            }

            move_uploaded_file($val, $this->upload_folder.$pic_id.$ext);
            @chmod($this->upload_folder.$pic_id.$ext, 0777);
            $val = $pic_id.$ext;
          } elseif ($_POST[fields][$I][delete]) $val = '';
          else $val = $mobj->DB_result($R, 0);
          break;
        case 'url':
          $val = $val[protocol].$val[address];
          break;
        case 'file_text':
          $mobj->SQL = "select $I from "._MOBJ_DB_TPREF_.$this->_table." where id='$id'";
          $R = $mobj->DB_db_query();

          if ($val[filename]!='' and (!file_exists($val[filename]) or $mobj->DB_num_rows($R)==0 or $mobj->DB_result($R, 0)==$val[filename])) {
            if ($fp = fopen($val[filename], 'w')) {
              fwrite($fp, trim(stripslashes($val[content])));
              fclose($fp);

              // Deleting old
              if ($mobj->DB_result($R, 0) != $val[filename]) @unlink($mobj->DB_result($R, 0));

              $val = $val[filename];
            }
          } else {
            $val = $mobj->DB_result($R, 0);
          }
          break;
      }

      if (!$tmp_quotes) $val = addslashes($val);
      $suf .= " $I='$val'";
      $J++;
    }

    $mobj->SQL = "update "._MOBJ_DB_TPREF_.$this->_table." set$suf where id='$id'";
    $R = $mobj->DB_db_query();
  }

  // Split picture file name onto name and extension
  function u15split_picture_fname($pic_fname)
  {
    preg_match("/\.([^\.]*?)$/", $pic_fname, $ext);
    $ext = strtolower($ext[0]);
    return array(substr($pic_fname,0,strlen($pic_fname)-strlen($ext)), $ext);
  }

  // Prepares fields of filter
  function u15prepare_filter_fields()
  {
    global $mobj;
    $mobj->SQL = "select _fields from "._MOBJ_DB_TPREF_."u15_filters where id='".$this->filter_id."'";
    $R = $mobj->DB_db_query();
    if ($mobj->DB_num_rows($R) == 1) {
      $tmp1 = explode('#', $mobj->DB_result($R,0));
      foreach ($tmp1 as $val) {
        $tmp2 = explode('|', $val);
        $tmp3 = $tmp2[0];
        unset($tmp2[0]);
        $filter_field_names[$tmp3] = $tmp2;
      }
      return $filter_field_names;
    }
  }

  // Makes query suffix basing on filter fields
  function u15make_add_query($field_names, $fields)
  {
    if (!is_array($fields)) return;
    foreach ($fields as $I=>$val) {
      if ($val) {
        if (!empty($out)) $out .= ' and ';
        if ($field_names[$I][1] == ' like ') $val = "%$val%";
        $out .= "$I".$field_names[$I][1]."'$val'";
      }
    }
    return $out;
  }

  // Prepares value of field depending on its type
  function u15prepare_field($field_value, $field_type)
  {
    switch ($field_type) {
      default:
        $out = $field_value;
        break;
      case 'select':
        $out = explode('###', $field_value);
        break;
    }
    return $out;
  }
}
?>